
// Librairies utilisées
#include "DHT.h"
#include "Seeed_BMP280.h"
#include <Wire.h>
#include <SoftwareSerial.h>

// Variables de sorties pour la station météo
float UV;           // Index UV
float temperature; //TEMPERATURE
float pression;    // PRESSION en pascal
float humid;       // HUMIDITE en %

// Déclaration des broches entrée-sortie
int PinUV = A0;              // Broche analogique sur laquelle sera connecté le capteur d'UV
int PinDHT = 2;              // Broche digitale sur laquelle sera connecté le capteur de temperature

DHT dht(PinDHT, DHT11);      // déclaration du capteur de température et d'humidité  raccordé à la broche digitale 2 de type DHT11
BMP280 bmp280;;              // Déclaration de l'objet bmp280 
SoftwareSerial mabluetooth(8, 9);   // Déclaration de la liaison série software BLU branché sur la Rx sera émulé par la broche 8, et Tx par la broche 9
                            // On remarquera que la broche 8=Rx de la carte Arduino est reliée à la broche Tx du module Bluetooth et inversement
// permet de laisser les broches 0 et 1 pour la communication entre l'ordinateur et la carte


// Initialisation
void setup()
{ Serial.begin(9600); // ouverture du moniteur série à 9600 bauds
  bmp280.init();
  mabluetooth.begin(9600); // Initialisation de la liaison bluetooth
  
}

//Boucle principale
void loop()
{ humid = 0;
//ACQUISITION ET CALCUL DE L'INDEX UV
      int b;
      long  sum=0;
      for(int i=0;i<1024;i++)            // boucle permettant de moyenner les valeurs lues
          { b=analogRead(PinUV);
            sum=b+sum;
            delay(2);}
      long meanVal = sum/1024;                // calcul de la valeur moyenne
      long UVindex= (meanVal*1000/4.3-83)/21; //formule extraite des données constructeurs pour le calcul de l'index UV
      UV = float(UVindex);                    // consersion de UV en float (réel)

 //ACQUISITION DE LA TEMPERATURE ,PRESSION
     temperature = bmp280.getTemperature(); //Acquisition de la température
     pression = bmp280.getPressure();      // Acquissition de la pression
 
//ACQUISITION DE L'HUMIDITE
  humid = dht.readHumidity();                                                   //Acquisition de l'humidité en %
  //temperature = dht.readTemperature(); // déjà acquise par le capteur bmp280
// ECRITURE DES VALEURS SUR LE MONITEUR SERIE
      Serial.print("index UV = ");
      Serial.println(UV);// get a detailed calculating expression for UV index in schematic files.

      Serial.print("temperature (en degréC) = ");
      Serial.println(temperature);

      Serial.print("Pression (en Pa)= ");
      Serial.println(pression);

      Serial.print("Humidité (en %) = ");
      Serial.println(humid);
  
    // ENVOI DES INFORMATIONS AU SMARTPHONE OU TABLETTE (à faire)







}
